# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from dbw_mkz_msgs/DriverAssistReport.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import std_msgs.msg

class DriverAssistReport(genpy.Message):
  _md5sum = "97f55d54ac7adaf52a6882520c5247ff"
  _type = "dbw_mkz_msgs/DriverAssistReport"
  _has_header = True  # flag to mark the presence of a Header object
  _full_text = """Header header

# Vehicle Decceleration (m/s^2)
float32 decel

# Deceleration source
uint8 decel_src
uint8 DECEL_NONE=0
uint8 DECEL_AEB=1
uint8 DECEL_ACC=2

# FCW Status
bool fcw_enabled
bool fcw_active

# AEB Status
bool aeb_enabled
bool aeb_precharge
bool aeb_braking

# ACC Status
bool acc_enabled
bool acc_braking

================================================================================
MSG: std_msgs/Header
# Standard metadata for higher-level stamped data types.
# This is generally used to communicate timestamped data 
# in a particular coordinate frame.
# 
# sequence ID: consecutively increasing ID 
uint32 seq
#Two-integer timestamp that is expressed as:
# * stamp.sec: seconds (stamp_secs) since epoch (in Python the variable is called 'secs')
# * stamp.nsec: nanoseconds since stamp_secs (in Python the variable is called 'nsecs')
# time-handling sugar is provided by the client library
time stamp
#Frame this data is associated with
# 0: no frame
# 1: global frame
string frame_id
"""
  # Pseudo-constants
  DECEL_NONE = 0
  DECEL_AEB = 1
  DECEL_ACC = 2

  __slots__ = ['header','decel','decel_src','fcw_enabled','fcw_active','aeb_enabled','aeb_precharge','aeb_braking','acc_enabled','acc_braking']
  _slot_types = ['std_msgs/Header','float32','uint8','bool','bool','bool','bool','bool','bool','bool']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       header,decel,decel_src,fcw_enabled,fcw_active,aeb_enabled,aeb_precharge,aeb_braking,acc_enabled,acc_braking

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(DriverAssistReport, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.header is None:
        self.header = std_msgs.msg.Header()
      if self.decel is None:
        self.decel = 0.
      if self.decel_src is None:
        self.decel_src = 0
      if self.fcw_enabled is None:
        self.fcw_enabled = False
      if self.fcw_active is None:
        self.fcw_active = False
      if self.aeb_enabled is None:
        self.aeb_enabled = False
      if self.aeb_precharge is None:
        self.aeb_precharge = False
      if self.aeb_braking is None:
        self.aeb_braking = False
      if self.acc_enabled is None:
        self.acc_enabled = False
      if self.acc_braking is None:
        self.acc_braking = False
    else:
      self.header = std_msgs.msg.Header()
      self.decel = 0.
      self.decel_src = 0
      self.fcw_enabled = False
      self.fcw_active = False
      self.aeb_enabled = False
      self.aeb_precharge = False
      self.aeb_braking = False
      self.acc_enabled = False
      self.acc_braking = False

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f8B().pack(_x.decel, _x.decel_src, _x.fcw_enabled, _x.fcw_active, _x.aeb_enabled, _x.aeb_precharge, _x.aeb_braking, _x.acc_enabled, _x.acc_braking))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.decel, _x.decel_src, _x.fcw_enabled, _x.fcw_active, _x.aeb_enabled, _x.aeb_precharge, _x.aeb_braking, _x.acc_enabled, _x.acc_braking,) = _get_struct_f8B().unpack(str[start:end])
      self.fcw_enabled = bool(self.fcw_enabled)
      self.fcw_active = bool(self.fcw_active)
      self.aeb_enabled = bool(self.aeb_enabled)
      self.aeb_precharge = bool(self.aeb_precharge)
      self.aeb_braking = bool(self.aeb_braking)
      self.acc_enabled = bool(self.acc_enabled)
      self.acc_braking = bool(self.acc_braking)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_3I().pack(_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs))
      _x = self.header.frame_id
      length = len(_x)
      if python3 or type(_x) == unicode:
        _x = _x.encode('utf-8')
        length = len(_x)
      buff.write(struct.Struct('<I%ss'%length).pack(length, _x))
      _x = self
      buff.write(_get_struct_f8B().pack(_x.decel, _x.decel_src, _x.fcw_enabled, _x.fcw_active, _x.aeb_enabled, _x.aeb_precharge, _x.aeb_braking, _x.acc_enabled, _x.acc_braking))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.header is None:
        self.header = std_msgs.msg.Header()
      end = 0
      _x = self
      start = end
      end += 12
      (_x.header.seq, _x.header.stamp.secs, _x.header.stamp.nsecs,) = _get_struct_3I().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      start = end
      end += length
      if python3:
        self.header.frame_id = str[start:end].decode('utf-8', 'rosmsg')
      else:
        self.header.frame_id = str[start:end]
      _x = self
      start = end
      end += 12
      (_x.decel, _x.decel_src, _x.fcw_enabled, _x.fcw_active, _x.aeb_enabled, _x.aeb_precharge, _x.aeb_braking, _x.acc_enabled, _x.acc_braking,) = _get_struct_f8B().unpack(str[start:end])
      self.fcw_enabled = bool(self.fcw_enabled)
      self.fcw_active = bool(self.fcw_active)
      self.aeb_enabled = bool(self.aeb_enabled)
      self.aeb_precharge = bool(self.aeb_precharge)
      self.aeb_braking = bool(self.aeb_braking)
      self.acc_enabled = bool(self.acc_enabled)
      self.acc_braking = bool(self.acc_braking)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_3I = None
def _get_struct_3I():
    global _struct_3I
    if _struct_3I is None:
        _struct_3I = struct.Struct("<3I")
    return _struct_3I
_struct_f8B = None
def _get_struct_f8B():
    global _struct_f8B
    if _struct_f8B is None:
        _struct_f8B = struct.Struct("<f8B")
    return _struct_f8B
